package //݂Ȃ̃pbP[WLĂ

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.opengl.GLES20;
import android.opengl.GLSurfaceView.Renderer;

public class MyGLESRenderer implements Renderer {

	private Context mContext;
	private FloatBuffer mVertexBuffer;

	private final float[] mVertexData = { 
			0.0f,  0.52f, 0.0f, 1.0f, 0.0f, 0.0f, 1.0f, 
		   -0.6f, -0.52f, 0.0f, 1.0f, 1.0f, 0.0f, 1.0f,
			0.6f, -0.52f, 0.0f, 0.0f, 1.0f, 0.0f, 1.0f
			};

    //gȂ
	//private final float uniColor[] = { 1.0f, 0, 0, 1.0f };

	private static final int FLOAT_SIZE_BYTES = 4;
	
	//ǉ
	private static final int XYZ_DATA_OFFSET =3;
	private static final int COLOR_DATA_OFFSET =4;
	private static final int XYZ_AND_COLOR_STRIDE = 7;
	private static final int NUMBER_OF_VERTICES =3;
	//܂


	private int mProgram;
	private int maPositionHandle;
	private int maColorHandle;
	//private int mvColorHandle;

	public MyGLESRenderer(Context context) {
		mContext = context;

		mVertexBuffer = allocateFloatBuffer(mVertexData.length);

		mVertexBuffer.put(mVertexData).position(0);

	}

	@Override
	public void onDrawFrame(GL10 unused) {
		// TODO ꂽ\bhEX^u
		GLES20.glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
		GLES20.glClear(GLES20.GL_COLOR_BUFFER_BIT);

		GLES20.glUseProgram(mProgram);
		
		mVertexBuffer.position(0);
		GLES20.glEnableVertexAttribArray(maPositionHandle);
		//GLES20.glVertexAttribPointer(maPositionHandle, 3, GLES20.GL_FLOAT,
		//		false, 0, mVertexBuffer);
		GLES20.glVertexAttribPointer(
				maPositionHandle, 
				XYZ_DATA_OFFSET, //3 萔
				GLES20.GL_FLOAT,  
					false,
				  XYZ_AND_COLOR_STRIDE*FLOAT_SIZE_BYTES, //0lύX
				mVertexBuffer); 


		//GLES20.glUniform4fv(mvColorHandle, 1, uniColor, 0);
		mVertexBuffer.position(XYZ_DATA_OFFSET);
		GLES20.glEnableVertexAttribArray(maColorHandle); //ǉ
		GLES20.glVertexAttribPointer(
				maColorHandle, //Ff[^̃nh
				COLOR_DATA_OFFSET, //RGBA4
				GLES20.GL_FLOAT,
					false,
				  XYZ_AND_COLOR_STRIDE*FLOAT_SIZE_BYTES, //XgCh
				mVertexBuffer);

		
		//GLES20.glDrawArrays(GLES20.GL_TRIANGLES, 0, 3);
		GLES20.glDrawArrays(
				GLES20.GL_TRIANGLES, 0, NUMBER_OF_VERTICES);


		
		GLES20.glDisableVertexAttribArray(maPositionHandle);
		GLES20.glDisableVertexAttribArray(maColorHandle); //ǉ
	}

	@Override
	public void onSurfaceChanged(GL10 unused, int width, int height) {
		
		GLES20.glViewport(0, 0, width, height);	
	}

	@Override
	public void onSurfaceCreated(GL10 unused, EGLConfig config) {
		mProgram = createProgram(vertexShaderCode, fragmentShaderCode);
		maPositionHandle = GLES20.glGetAttribLocation(mProgram, "aPosition");
		
		maColorHandle = 
				GLES20.glGetAttribLocation(mProgram, "aColor"); //ύX

		//mvColorHandle = GLES20.glGetUniformLocation(mProgram, "vColor");

	}

	private FloatBuffer allocateFloatBuffer(int dataLength) {
		return ByteBuffer.allocateDirect(dataLength * FLOAT_SIZE_BYTES)
				.order(ByteOrder.nativeOrder()).asFloatBuffer();

	}

	private int loadShader(int shaderType, String source) {
		int shader = GLES20.glCreateShader(shaderType);
		GLES20.glShaderSource(shader, source);
		GLES20.glCompileShader(shader);

		return shader;
	}

	private int createProgram(String vertexSource, String fragmentSource) {

		int vertexShader = loadShader(GLES20.GL_VERTEX_SHADER, vertexSource);
		int fragmentShader = loadShader(GLES20.GL_FRAGMENT_SHADER,
				fragmentSource);

		int program = GLES20.glCreateProgram();

		GLES20.glAttachShader(program, vertexShader);
		GLES20.glAttachShader(program, fragmentShader);

		GLES20.glLinkProgram(program);

		return program;

	}

	private final String vertexShaderCode =
			"attribute vec4 aPosition;" +
	        "attribute vec4 aColor;"+ //ǉ
			"varying vec4 vColor;"+  //ǉ
		    "void main() {" +
		    "  gl_Position = aPosition;" +
		    "  vColor = aColor;"+
		    "}";

	private final String fragmentShaderCode =
		    "precision lowp float;" +
	        "varying vec4 vColor;"+  //ύX
		 //   "uniform vec4 vColor;" +
		    "void main() {" +
		    "  gl_FragColor = vColor;" +
		    "}";

}
