package //݂Ȃ̃pbP[WLĂ

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.ShortBuffer;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.opengl.GLES20;
import android.opengl.GLSurfaceView.Renderer;
import android.opengl.Matrix;

public class MyGLESRenderer implements Renderer {

	private Context mContext;
	private FloatBuffer mVertexBuffer;
	private ShortBuffer mDrawOrderBuffer;

	private final float[] mVertexData = { 
		0.0f, 0.8f, 0.0f, 1.0f, 0.0f, 0.0f, 1.0f, //s
	    0.0f, 0.0f, 0.52f, 1.0f, 1.0f, 0.0f, 1.0f, //グ
		0.6f, 0.0f, -0.52f, 0.0f, 1.0f, 0.0f, 1.0f, //
		-0.6f, 0.0f, -0.52f, 1.0f, 0.0f, 1.0f, 1.0f //	

		};

	private short mDrawOrder[] ={
		0, 1, 2,
		0, 2, 3, //
		0, 3, 1,
		1, 3, 2 //
	};


	private static final int FLOAT_SIZE_BYTES = 4;
	private static final int SHORT_SIZE_BYTES = 2;
	

	private static final int XYZ_DATA_OFFSET =3;
	private static final int COLOR_DATA_OFFSET =4;
	private static final int XYZ_AND_COLOR_STRIDE = 7;
	private static final int NUMBER_OF_VERTICES =3;



	private int mProgram;
	private int maPositionHandle;
	private int maColorHandle;
	private int muMVPMatrixHandle;
	
	private float[] mPMatrix = new float[16];
	private float[] mVMatrix = new float[16];
	private float[] mMVPMatrix = new float[16];
	private float[] mRotMatrix = new float[16];


	public MyGLESRenderer(Context context) {
		mContext = context;

		mVertexBuffer = allocateFloatBuffer(mVertexData.length);
        mVertexBuffer.put(mVertexData).position(0);
		
        mDrawOrderBuffer = allocateShortBuffer(mDrawOrder.length);
        mDrawOrderBuffer.put(mDrawOrder).position(0);

	}

	@Override
	public void onDrawFrame(GL10 unused) {
		
		GLES20.glEnable(GLES20.GL_CULL_FACE);
		GLES20.glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
		GLES20.glClear(GLES20.GL_COLOR_BUFFER_BIT);

		GLES20.glUseProgram(mProgram);
		
		mVertexBuffer.position(0);

		GLES20.glEnableVertexAttribArray(maPositionHandle);
		GLES20.glVertexAttribPointer(
			maPositionHandle, XYZ_DATA_OFFSET,
		    GLES20.GL_FLOAT, false, 
		    XYZ_AND_COLOR_STRIDE*FLOAT_SIZE_BYTES,
		    mVertexBuffer);  
				
		mVertexBuffer.position(XYZ_DATA_OFFSET); 
				
		GLES20.glEnableVertexAttribArray(maColorHandle);
		GLES20.glVertexAttribPointer(
		    maColorHandle, COLOR_DATA_OFFSET, 
		GLES20.GL_FLOAT, false, 
		    XYZ_AND_COLOR_STRIDE*FLOAT_SIZE_BYTES, 
		    mVertexBuffer);

		Matrix.setLookAtM(
				mVMatrix, 0, 
				0, 0, 5, 
				0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f); 

		Matrix.setRotateM(
				mRotMatrix, //ʂ
				0,  //@f[^̓ǂݔ΂Ȃꍇ0
				-5.0f, // ]px
				1.0f, // xSȂ炱1.0f
				0.0f, //@  ySȂ炱1.0f
				0.0f); //@ zSȂ炱1.0f

		Matrix.multiplyMM(
				mMVPMatrix, 0, mVMatrix, 0, mRotMatrix, 0);

		Matrix.multiplyMM(
				mMVPMatrix, 0, mPMatrix, 0, mMVPMatrix, 0);


		GLES20.glUniformMatrix4fv(
				muMVPMatrixHandle,
				 1, //ЂƂ̔z񂵂Ȃ̂1
				false, //sƗ̓ւsǂBʂfalse
				mMVPMatrix, 
				0 //f[^̓ǂݔ΂Ȃ0
				);

				
		GLES20.glDrawElements(
				GLES20.GL_TRIANGLES,
				mDrawOrder.length,
				GLES20.GL_UNSIGNED_SHORT,
				mDrawOrderBuffer
		);

		GLES20.glDisableVertexAttribArray(maPositionHandle);
		GLES20.glDisableVertexAttribArray(maColorHandle);
	}

	@Override
	public void onSurfaceChanged(GL10 unused, int width, int height) {
		
		GLES20.glViewport(0, 0, width, height);	
		
		float ratio =(float)width/height;
		Matrix.frustumM(mPMatrix, 0, -ratio, ratio, -1, 1,
				 3, 7);

	}

	@Override
	public void onSurfaceCreated(GL10 unused, EGLConfig config) {
		mProgram = createProgram(vertexShaderCode, fragmentShaderCode);
		maPositionHandle = GLES20.glGetAttribLocation(mProgram, "aPosition");
		
		maColorHandle = GLES20.glGetAttribLocation(mProgram, "aColor"); 

		muMVPMatrixHandle = 
				GLES20.glGetUniformLocation(mProgram, "uMVPMatrix");



	}

	private FloatBuffer allocateFloatBuffer(int dataLength) {
		return ByteBuffer.allocateDirect(dataLength * FLOAT_SIZE_BYTES)
				.order(ByteOrder.nativeOrder()).asFloatBuffer();

	}
	
	private ShortBuffer allocateShortBuffer(int dataLength) {
		return ByteBuffer.allocateDirect(dataLength * SHORT_SIZE_BYTES)
				.order(ByteOrder.nativeOrder()).asShortBuffer();
	}


	private int loadShader(int shaderType, String source) {
		int shader = GLES20.glCreateShader(shaderType);
		GLES20.glShaderSource(shader, source);
		GLES20.glCompileShader(shader);

		return shader;
	}

	private int createProgram(String vertexSource, String fragmentSource) {

		int vertexShader = loadShader(GLES20.GL_VERTEX_SHADER, vertexSource);
		int fragmentShader = loadShader(GLES20.GL_FRAGMENT_SHADER,
				fragmentSource);

		int program = GLES20.glCreateProgram();

		GLES20.glAttachShader(program, vertexShader);
		GLES20.glAttachShader(program, fragmentShader);

		GLES20.glLinkProgram(program);

		return program;

	}

	private final String vertexShaderCode =
			"uniform mat4 uMVPMatrix;" +
			"attribute vec4 aPosition;" +
	        "attribute vec4 aColor;"+
			"varying vec4 vColor;"+ 
		    "void main() {" +
		    "  gl_Position = uMVPMatrix*aPosition;" +
		    "  vColor = aColor;"+
		    "}";

	private final String fragmentShaderCode =
		    "precision lowp float;" +
	        "varying vec4 vColor;"+
		    "void main() {" +
		    "  gl_FragColor = vColor;" +
		    "}";

}
