package //݂Ȃ̃pbP[WLĂg

import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.ShortBuffer;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLES20;
import android.opengl.Matrix;
import android.opengl.GLSurfaceView.Renderer;
import android.opengl.GLUtils;

public class MyGLESRenderer implements Renderer {

	private Context mContext;
	private FloatBuffer mVertexBuffer;
	private ShortBuffer mDrawOrderBuffer;

	private final float[] mVertexData = { 
	  0.0f, 0.8f, 0.0f, 0.5f, 0.0f, //0
	  0.0f, 0.0f, 0.52f, 0.0f, 1.0f, //1
	  0.6f, 0.0f, -0.52f, 1.0f, 1.0f, //2
				
	  0.0f, 0.8f, 0.0f, 0.5f, 0.0f, //0
	  0.6f, 0.0f, -0.52f, 0.0f, 1.0f, //2
	  -0.6f, 0.0f, -0.52f, 1.0f, 1.0f, //3
		   		   
	  0.0f, 0.8f, 0.0f, 0.5f, 0.0f, //0
	 -0.6f, 0.0f, -0.52f, 0.0f, 1.0f, //3
	  0.0f, 0.0f, 0.52f, 1.0f, 1.0f, //1   
		    
	  0.0f, 0.0f, 0.52f,  0.5f, 0.0f, //1
	 -0.6f, 0.0f, -0.52f, 0.0f, 1.0f,//3
	  0.6f, 0.0f, -0.52f, 1.0f, 1.0f, //2		
	};
			
	private short mDrawOrder[] ={0,1,2,3,4,5,6,7,8,9,10,11};



	private static final int FLOAT_SIZE_BYTES = 4;
	private static final int SHORT_SIZE_BYTES = 2;
	
	private static final int XYZ_DATA_OFFSET =3;
	private static final int TEX_DATA_OFFSET=2;
	private static final int VERTEX_AND_TEX_STRIDE=5;


	private int mProgram;
	private int maPositionHandle;
	private int muMVPMatrixHandle;
	private int maTexHandle;
	
	private float[] mPMatrix = new float[16];
	private float[] mVMatrix = new float[16];
	private float[] mMVPMatrix = new float[16];
	private float[] mRotMatrix = new float[16];

	private float mAngle;
	
	
	private int mTexID;


	public MyGLESRenderer(Context context) {
		mContext = context;

		mVertexBuffer = allocateFloatBuffer(mVertexData.length);
		mVertexBuffer.put(mVertexData).position(0);
		
        mDrawOrderBuffer = allocateShortBuffer(mDrawOrder.length);
        mDrawOrderBuffer.put(mDrawOrder).position(0);
	}

	@Override
	public void onDrawFrame(GL10 unused) {
		// TODO ꂽ\bhEX^u
		
		GLES20.glEnable(GLES20.GL_CULL_FACE);
		GLES20.glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
		GLES20.glClear(GLES20.GL_COLOR_BUFFER_BIT);

		GLES20.glUseProgram(mProgram);
		
		//ȑO珑ĂȂ珑
		mVertexBuffer.position(0);

		GLES20.glEnableVertexAttribArray(maPositionHandle);
		GLES20.glVertexAttribPointer(
		  maPositionHandle, XYZ_DATA_OFFSET, 
		  GLES20.GL_FLOAT,false,
		  VERTEX_AND_TEX_STRIDE*FLOAT_SIZE_BYTES, //ύX
		  mVertexBuffer);

		//ȑO珑ĂȂ珑
		mVertexBuffer.position(XYZ_DATA_OFFSET);

		GLES20.glEnableVertexAttribArray(maTexHandle);
		GLES20.glVertexAttribPointer(
		  maTexHandle, TEX_DATA_OFFSET, 
		  GLES20.GL_FLOAT,false,
		  VERTEX_AND_TEX_STRIDE*FLOAT_SIZE_BYTES,
		  mVertexBuffer);
		
		
		Matrix.setLookAtM(
				mVMatrix, 0, 
				0.0f, 0.0f, 4.0f, //Ɛڋ
				0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f);
		
         mAngle +=0.4f;
		
		Matrix.setIdentityM(mRotMatrix, 0);
		Matrix.rotateM(mRotMatrix, 0, mAngle, 1.0f, 1.0f, 1.0f);

		Matrix.multiplyMM(
				mMVPMatrix, 0, mVMatrix, 0, mRotMatrix, 0);

		Matrix.multiplyMM(
				mMVPMatrix, 0, mPMatrix, 0, mMVPMatrix, 0);
		
		GLES20.glUniformMatrix4fv(
				muMVPMatrixHandle, 1, false, mMVPMatrix, 0 );
		
		GLES20.glDrawElements(
				GLES20.GL_TRIANGLES,
				mDrawOrder.length,
				GLES20.GL_UNSIGNED_SHORT,
				mDrawOrderBuffer
		);
		
		GLES20.glDisableVertexAttribArray(maPositionHandle);
		GLES20.glDisableVertexAttribArray(maTexHandle);
	}

	@Override
	public void onSurfaceChanged(GL10 unused, int width, int height) {
		
		GLES20.glViewport(0, 0, width, height);	
		float ratio =(float)width/height;
		Matrix.frustumM(
           mPMatrix, 0, 
           -ratio, ratio, -1, 1,
			3, 7
        );

	}

	@Override
	public void onSurfaceCreated(GL10 unused, EGLConfig config) {
		mProgram = createProgram(vertexShaderCode, fragmentShaderCode);
		maPositionHandle = GLES20.glGetAttribLocation(mProgram, "aPosition");
		muMVPMatrixHandle = GLES20.glGetUniformLocation(mProgram, "uMVPMatrix");
		maTexHandle = 
				GLES20.glGetAttribLocation(mProgram, "aTexture");

		initTexture(R.raw.heart256);
	}

	private FloatBuffer allocateFloatBuffer(int dataLength) {
		return ByteBuffer.allocateDirect(dataLength * FLOAT_SIZE_BYTES)
				.order(ByteOrder.nativeOrder()).asFloatBuffer();

	}
	
	private ShortBuffer allocateShortBuffer(int dataLength) {
		return ByteBuffer.allocateDirect(dataLength * SHORT_SIZE_BYTES)
				.order(ByteOrder.nativeOrder()).asShortBuffer();
	}

	private int loadShader(int shaderType, String source) {
		int shader = GLES20.glCreateShader(shaderType);
		GLES20.glShaderSource(shader, source);
		GLES20.glCompileShader(shader);

		return shader;
	}

	private int createProgram(String vertexSource, String fragmentSource) {

		int vertexShader = loadShader(GLES20.GL_VERTEX_SHADER, vertexSource);
		int fragmentShader = loadShader(GLES20.GL_FRAGMENT_SHADER,
				fragmentSource);

		int program = GLES20.glCreateProgram();

		GLES20.glAttachShader(program, vertexShader);
		GLES20.glAttachShader(program, fragmentShader);

		GLES20.glLinkProgram(program);

		return program;

	}

	private final String vertexShaderCode =
		"uniform mat4 uMVPMatrix;" +
		"attribute vec4 aPosition;" +
		"attribute vec2 aTexture;"+
		"varying vec2 vTexture;"+
		"void main() {" +
		"  gl_Position = uMVPMatrix*aPosition;" +
		"  vTexture = aTexture;"+
		"}";

	private final String fragmentShaderCode =
			"precision lowp float;" +
			"varying vec2 vTexture;"+
			"uniform sampler2D sTexture;"+
			"void main() {" +
			"  gl_FragColor = texture2D(sTexture, vTexture);" +
			"}";


	private void loadTexture(int ResourceID){
		InputStream is = 
			mContext.getResources().openRawResource(ResourceID);
		
	    Bitmap bmp;
			try{
				bmp = BitmapFactory.decodeStream(is);
			}finally{
				try{
					 is.close();
				}catch(IOException e){}
			}
		
		GLUtils.texImage2D(GLES20.GL_TEXTURE_2D, 0, bmp, 0);
	    bmp.recycle();
	}
	
	private void initTexture(int ResourceID){
		
		//(1)eNX`f[^̔z쐬Bł̓f[^͂ЂƂ
			int[] texs = new int[1];
			GLES20.glGenTextures(1, texs, 0); //u1vID
			
		//(2)o[ϐɃeNX`IDu1v
		mTexID = texs[0];
			

		//(3)umTexIDɂĂꂩݒ肵܂v
		GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, mTexID);
			
		//(4)eNX`̑傫̎
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MIN_FILTER, GLES20.GL_NEAREST);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
			  GLES20.GL_TEXTURE_MAG_FILTER, GLES20.GL_LINEAR);
		
		//(5)摜ꍇA^Cɓ\ĂƂw
		GLES20.glTexParameteri(GLES20.GL_TEXTURE_2D, 
			GLES20.GL_TEXTURE_WRAP_S, GLES20.GL_REPEAT);
		GLES20.glTexParameteri(GLES20.GL_TEXTURE_2D, 
			GLES20.GL_TEXTURE_WRAP_T, GLES20.GL_REPEAT);
			
		loadTexture(ResourceID); //(6)Xg7-3Œ`\bh

	}
			


}
