package //݂Ȃ̃pbP[WLĂ

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;

import android.opengl.GLES20;

public class MyTriangle {
	
	private FloatBuffer mVertexBuffer;

	private final float[] mVertexData = { 
		0.0f,  0.52f, 0.0f, 1.0f, 0.2f, 0.2f, 1.0f, //sN
	   -0.6f, -0.52f, 0.0f, 1.0f, 1.0f, 0.0f, 1.0f, //F
		0.6f, -0.52f, 0.0f, 1.0f, 0.5f, 0.0f, 1.0f //F
    };

	private static final int FLOAT_SIZE_BYTES = 4;
	private static final int XYZ_DATA_OFFSET =3;
	private static final int COLOR_DATA_OFFSET =4;
	private static final int XYZ_AND_COLOR_STRIDE = 7;
	private static final int NUMBER_OF_VERTICES =3;

	private int mProgram;
	private int maPositionHandle;
	private int maColorHandle;
	
	public MyTriangle(){
		
		mVertexBuffer = allocateFloatBuffer(mVertexData.length);
		mVertexBuffer.put(mVertexData).position(0);
		
		mProgram = createProgram(vertexShaderCode, fragmentShaderCode);
		maPositionHandle = GLES20.glGetAttribLocation(mProgram, "aPosition");
		maColorHandle = 
				GLES20.glGetAttribLocation(mProgram, "aColor"); 
	
	}
	
	public void draw(){
		
        GLES20.glUseProgram(mProgram);
		
		mVertexBuffer.position(0);
		GLES20.glEnableVertexAttribArray(maPositionHandle);
		GLES20.glVertexAttribPointer(
		  maPositionHandle, XYZ_DATA_OFFSET, GLES20.GL_FLOAT, false,
				XYZ_AND_COLOR_STRIDE*FLOAT_SIZE_BYTES,mVertexBuffer); 

		mVertexBuffer.position(XYZ_DATA_OFFSET);
		GLES20.glEnableVertexAttribArray(maColorHandle);
		GLES20.glVertexAttribPointer(
		  maColorHandle, COLOR_DATA_OFFSET, GLES20.GL_FLOAT, false,
				XYZ_AND_COLOR_STRIDE*FLOAT_SIZE_BYTES,mVertexBuffer);

		GLES20.glDrawArrays(
				GLES20.GL_TRIANGLES, 0, NUMBER_OF_VERTICES);
	
		GLES20.glDisableVertexAttribArray(maPositionHandle);
		GLES20.glDisableVertexAttribArray(maColorHandle); 
		
	}
	
	private FloatBuffer allocateFloatBuffer(int dataLength) {
		return ByteBuffer.allocateDirect(dataLength * FLOAT_SIZE_BYTES)
				.order(ByteOrder.nativeOrder()).asFloatBuffer();

	}

	private int loadShader(int shaderType, String source) {
		int shader = GLES20.glCreateShader(shaderType);
		GLES20.glShaderSource(shader, source);
		GLES20.glCompileShader(shader);

		return shader;
	}

	private int createProgram(String vertexSource, String fragmentSource) {

		int vertexShader = loadShader(GLES20.GL_VERTEX_SHADER, vertexSource);
		int fragmentShader = loadShader(GLES20.GL_FRAGMENT_SHADER,
				fragmentSource);

		int program = GLES20.glCreateProgram();

		GLES20.glAttachShader(program, vertexShader);
		GLES20.glAttachShader(program, fragmentShader);

		GLES20.glLinkProgram(program);

		return program;

	}

	
	private final String vertexShaderCode =
			"attribute vec4 aPosition;" +
	        "attribute vec4 aColor;"+
			"varying vec4 vColor;"+ 
		    "void main() {" +
		    "  gl_Position = aPosition;" +
		    "  vColor = aColor;"+
		    "}";

	private final String fragmentShaderCode =
		    "precision lowp float;" +
	        "varying vec4 vColor;"+ 
		    "void main() {" +
		    "  gl_FragColor = vColor;" +
		    "}";



}
