package //݂Ȃ̃pbP[WLĂ


import java.io.IOException;
import java.io.InputStream;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLES20;
import android.opengl.GLUtils;
import android.opengl.Matrix;
import android.opengl.GLSurfaceView.Renderer;

public class MyGLESRenderer implements Renderer {

	private Context mContext;
	private MyTriangle mTriangle;
	private MySquare mSquare;
	
	private int mProgram;
	private int maPositionHandle;
	private int mvColorHandle;
	private int muMVPMatrixHandle;
	
	private float[] mPMatrix = new float[16];
	private float[] mVMatrix = new float[16];
	private float[] mMVPMatrix = new float[16];
	private float[] mTransMatrix = new float[16];
	
	private int mTexID;

	public MyGLESRenderer(Context context) {
		mContext = context;
        
	}

	@Override
	public void onDrawFrame(GL10 unused) {
		
		GLES20.glEnable(GLES20.GL_DEPTH_TEST);
		GLES20.glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
		GLES20.glClear(GLES20.GL_COLOR_BUFFER_BIT|GLES20.GL_DEPTH_BUFFER_BIT);
		
		Matrix.setLookAtM(
				mVMatrix, 0, 
				0.0f, 0.0f, 5.0f, 
				0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f);
		
		Matrix.setIdentityM(mTransMatrix, 0);
		Matrix.translateM(mTransMatrix,0, 0.2f, 0.2f, 0);
		Matrix.multiplyMM(
		mMVPMatrix, 0, mVMatrix, 0, mTransMatrix, 0);
		Matrix.multiplyMM(
		mMVPMatrix, 0, mPMatrix, 0, mMVPMatrix, 0);

		initTexture(R.raw.rose256);

		mTriangle.draw(mMVPMatrix);

		//lp`̕`		
		Matrix.setIdentityM(mTransMatrix, 0);
		Matrix.translateM(mTransMatrix, 0, -0.2f, 0.0f, -1.5f);
		Matrix.multiplyMM(
		mMVPMatrix, 0, mVMatrix, 0, mTransMatrix, 0);
		Matrix.multiplyMM(
		mMVPMatrix, 0, mPMatrix, 0, mMVPMatrix, 0);
				
		initTexture(R.raw.check256);
				
		mSquare.draw(mMVPMatrix);

	}

	@Override
	public void onSurfaceChanged(GL10 unused, int width, int height) {
		
		GLES20.glViewport(0, 0, width, height);	
		
		float ratio =(float)width/height;
		Matrix.frustumM(
           mPMatrix, 0, 
           -ratio, ratio, -1, 1,
			3, 7
        );
	}

	@Override
	public void onSurfaceCreated(GL10 unused, EGLConfig config) {
		mTriangle= new MyTriangle();
		mSquare = new MySquare();

	}

	private void loadTexture(int ResourceID){
		InputStream is = 
			mContext.getResources().openRawResource(ResourceID);
		
	    Bitmap bmp;
			try{
				bmp = BitmapFactory.decodeStream(is);
			}finally{
				try{
					 is.close();
				}catch(IOException e){}
			}
		
		GLUtils.texImage2D(GLES20.GL_TEXTURE_2D, 0, bmp, 0);
	    bmp.recycle();
	}
	
	private void initTexture(int ResourceID){
		
		//(1)eNX`f[^̔z쐬Bł̓f[^͂ЂƂ
			int[] texs = new int[1];
			GLES20.glGenTextures(1, texs, 0); //u1vID
			
		//(2)o[ϐɃeNX`IDu1v
		mTexID = texs[0];
			

		//(3)umTexIDɂĂꂩݒ肵܂v
		GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, mTexID);
			
		//(4)eNX`̑傫̎
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MIN_FILTER, GLES20.GL_NEAREST);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
			  GLES20.GL_TEXTURE_MAG_FILTER, GLES20.GL_LINEAR);
		
		//(5)摜ꍇA^Cɓ\ĂƂw
		GLES20.glTexParameteri(GLES20.GL_TEXTURE_2D, 
			GLES20.GL_TEXTURE_WRAP_S, GLES20.GL_REPEAT);
		GLES20.glTexParameteri(GLES20.GL_TEXTURE_2D, 
			GLES20.GL_TEXTURE_WRAP_T, GLES20.GL_REPEAT);
			
		loadTexture(ResourceID); //(6)Xg7-3Œ`\bh
	}

}
